#if !defined (_Gauges_h_)
#define _Gauges_h_
// ANSI includes

// Application includes
#include <Application.h>
#include <View.h>
#include <Window.h>
#include <StringView.h>
#include "Mlm78.h"


class _EXPORT Gauges; // the dragger part has to be exported

class Gauges : public BView
{	public: // constructors & destructors
		Gauges(BRect frame, const char *name, uint32 resizeMask = B_FOLLOW_LEFT | B_FOLLOW_TOP, uint32 flags = B_WILL_DRAW | B_NAVIGABLE | B_PULSE_NEEDED);
		Gauges(BMessage *);	// BMessage * based constructor needed to support archiving
		virtual ~Gauges();
	
		// archiving overrides
		static Gauges *Instantiate(BMessage *data);
		virtual	status_t Archive(BMessage *data, bool deep = true) const;
	
		virtual void AttachedToWindow();	
		virtual void MouseDown(BPoint);
		
		virtual void Pulse();
		virtual void Draw(BRect );
	
		virtual void MessageReceived(BMessage *);

	private: // methods

	private: // instance variables
		bool	init_;
		int		state_;
		Mlm78	lm78_;
};

#endif // _Gauges_h_
